﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Tibero.DataAccess.Client; // Tibero 라이브러리 추가 
using System.Data;

namespace tibero_tdpnet_samples
{
    class SampleTDP
    {

        public void ExecuteSample()
        {
            try
            {
                Console.WriteLine(" == ExecuteSample 함수 시작  == ");
                //Connect String 설정 
                string tbconnstr = "User Id=" + "tibero" + " ; Password=" + "tmax" + ";Data Source = (INSTANCE =(HOST=" + "127.0.0.1" + ")(PORT=" + 17000 + ")(DB_NAME=" + "tibero" + ")";

                //Connect 연결
                using (TiberoConnection conn = new TiberoConnection(tbconnstr))
                {
                    conn.Open();

                    TiberoCommand cmd = new TiberoCommand();
                    cmd.Connection = conn;
                    cmd.CommandText = "PROC_INSERT";
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.BindByName = true;

                    //parameter Set Case1 
                    Console.WriteLine("========= data Bind Case1 ==============");
                    TiberoParameter in_col_num = new TiberoParameter();
                    in_col_num.Direction = ParameterDirection.Input;
                    in_col_num.TiberoDbType = TiberoDbType.Decimal;
                    in_col_num.ParameterName = "in_col_num";
                    in_col_num.Value = "1";
                    cmd.Parameters.Add(in_col_num);

                    TiberoParameter in_col_varchar = new TiberoParameter();
                    in_col_varchar.Direction = ParameterDirection.Input;
                    in_col_varchar.TiberoDbType = TiberoDbType.Varchar2;
                    in_col_varchar.Size = 4000;
                    in_col_varchar.ParameterName = "in_col_vchar";
                    in_col_varchar.Value = "test bind varchar case1 ";
                    cmd.Parameters.Add(in_col_varchar);


                    //Query 실행
                    cmd.ExecuteNonQuery();
                    cmd.Parameters.Clear();

                    cmd.CommandText = "SELECT COL1_NUMBER , COL2_VARCHAR FROM SAMPLETABLE";
                    cmd.CommandType = CommandType.Text;


                    TiberoDataReader dr = null;
                    dr = cmd.ExecuteReader();
                    //Tibero DataReader
                    while (dr.Read())
                    {
                        Console.Write("COL1_NUMBER  : [" + dr.GetDecimal(0) + "]");
                        Console.Write(" - ");
                        Console.WriteLine("COL2_VARCHAR : [" + dr.GetValue(1) + "]");

                    }

                    //parameter set Case2
                    Console.WriteLine("========= data Bind Case2 ==============");
                    cmd.Parameters.Add("in_col_num", TiberoDbType.Decimal).Value = 2;
                    cmd.Parameters.Add("in_col_vchar", TiberoDbType.Varchar2, 4000).Value = "test bind varchar case2";


                    cmd.CommandText = "SELECT COL1_NUMBER , COL2_VARCHAR FROM SAMPLETABLE";
                    cmd.CommandType = CommandType.Text;

                    dr = cmd.ExecuteReader();
                   
                    while (dr.Read())
                    {
                        Console.Write("COL1_NUMBER  : [" + dr.GetDecimal(0) + "]");
                        Console.Write(" - ");
                        Console.WriteLine("COL2_VARCHAR : [" + dr.GetValue(1) + "]");

                    }

                    cmd.CommandText = "delete from SAMPLETABLE";
                    cmd.CommandType = CommandType.Text;
                    cmd.ExecuteNonQuery();

                    //자원 해제
                    in_col_num.Dispose();
                    dr.Dispose();
                    conn.Close();

                    Console.WriteLine(" == ExecuteSample 함수 종료  == ");
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.WriteLine(e.ToString());
                Console.ReadLine();
            }

        }


        static void Main(string[] args)
        {
            try
            {
                Console.WriteLine(" == START  == ");
                Console.WriteLine("\n");
                SampleTDP sample = new SampleTDP();
                sample.ExecuteSample();
                Console.WriteLine("\n");
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.WriteLine(e.ToString());

            }
            Console.WriteLine(" == Success == ");
            Console.ReadLine();
        }

    }
}
